/*
   Project: Berkelium

   Copyright (C) 2012 Free Software Foundation

   Author: Gregory John Casamento,,,

   Created: 2012-06-24 18:56:36 -0400 by heron

   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA.
*/

#ifndef _BERKELIUM_H_
#define _BERKELIUM_H_

#import <Foundation/Foundation.h>
#import <AppKit/NSImageView.h>

// Include C++ lib...
#include <berkelium/Berkelium.hpp>
#include <berkelium/Window.hpp>

@interface BerkeliumKit : NSImageView
{
  NSTimer *_updateTimer;
  NSString *_url;
  Berkelium::Window *_bwindow;
}

- (void) update: (NSTimer *)timer;
- (void) onPaint: (NSImage *)image;
- (void) setMainFrameURL: (NSString *)theURL;
@end

#endif // _BERKELIUM_H_

